"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
const core = require("api-service-core");
const plugins_1 = require("./plugins");
var plugins_2 = require("./plugins");
exports.amqp = plugins_2.amqp;
exports.cors = plugins_2.cors;
exports.harden = plugins_2.harden;
exports.KeycloakPlugin = plugins_2.KeycloakPlugin;
exports.remote_config = plugins_2.remote_config;
exports.prometheus = plugins_2.prometheus;
exports.ua = plugins_2.ua;
exports.render = plugins_2.render;
exports.webhooks = plugins_2.webhooks;
exports.UMA = plugins_2.UMA;
const middleware_1 = require("./middleware");
var middleware_2 = require("./middleware");
exports.apidocs = middleware_2.apidocs;
exports.api_config = middleware_2.api_config;
exports.decrypt = middleware_2.decrypt;
exports.encrypt = middleware_2.encrypt;
exports.local_file = middleware_2.local_file;
exports.redact = middleware_2.redact;
exports.redirect = middleware_2.redirect;
exports.static_assets = middleware_2.static_assets;
var api_service_core_1 = require("api-service-core");
exports.Chassis = api_service_core_1.Chassis;
/*
        Register all our default plugins
        These can are installed before the server starts listening
 */
let default_plugins = function () {
    this.registerPlugin(new plugins_1.amqp);
    this.registerPlugin(new plugins_1.cors);
    this.registerPlugin(new plugins_1.harden);
    this.registerPlugin(new plugins_1.KeycloakPlugin);
    this.registerPlugin(new plugins_1.UMA);
    this.registerPlugin(new plugins_1.prometheus);
    this.registerPlugin(new plugins_1.ua);
    this.registerPlugin(new plugins_1.render);
    this.registerPlugin(new plugins_1.remote_config);
    this.registerPlugin(new plugins_1.webhooks);
    this.registerPlugin(new core.PipelinePlugin);
    this.registerPlugin(new core.after);
    this.registerPlugin(new core.before);
    this.registerPlugin(new core.graphql);
    this.registerPlugin(new core.logging);
    this.registerPlugin(new core.jwt);
    this.registerPlugin(new core.payload);
    this.registerPlugin(new core.OpenAPIPlugin);
};
/*
        Register all our middleware plugins
        These can be attached as chassis:operations to Open API specs
 */
let default_middleware = function () {
    this.registerFn(new core.bower_components);
    this.registerFn(new core.debug);
    this.registerFn(new core.DataDict);
    this.registerFn(new core.echo);
    this.registerFn(new core.gregarious);
    this.registerFn(new core.heartbeat);
    this.registerFn(new core.headers);
    this.registerFn(new core.mock);
    this.registerFn(new core.mount);
    this.registerFn(new core.not_found);
    this.registerFn(new core.proxy);
    this.registerFn(new core.request_uuid);
    this.registerFn(new core.sortby);
    this.registerFn(new middleware_1.apidocs);
    this.registerFn(new middleware_1.decrypt);
    this.registerFn(new middleware_1.encrypt);
    this.registerFn(new middleware_1.local_file);
    this.registerFn(new middleware_1.api_config);
    this.registerFn(new middleware_1.redact);
    this.registerFn(new middleware_1.redirect);
    this.registerFn(new middleware_1.static_assets);
};
function default_features() {
    default_plugins.apply(this);
    default_middleware.apply(this);
}
exports.default_features = default_features;
//# sourceMappingURL=index.js.map