"use strict";
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const api_service_core_1 = require("api-service-core");
const _ = require("lodash");
/**
 * Inline Configuration
 * -------------
 * Attach an API resource to serve 'feature.config'
 *
 *
 * @type {{name: string, title: string, description: string, fn: module.exports.fn}}
 */
class api_config {
    constructor() {
        this.name = "api.config";
        this.title = "Config API";
    }
    fn(operation, options) {
        let context = operation.context;
        assert(context, "missing context");
        return function (_req, res) {
            let remote_config = _.extend({}, context.config.remote_config, options.config);
            // console.log("api.config [remote_config]: %o", remote_config);
            // parse external @ files
            remote_config = api_service_core_1.Vars.resolve_externals(remote_config);
            // interpolate variables
            remote_config = api_service_core_1.Vars.resolve(remote_config, context.config);
            res.status(200);
            res.send(remote_config);
        };
    }
}
exports.default = api_config;
;
//# sourceMappingURL=api_config.js.map