/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
import { IOperation, IChassisContext, IChassisFeature, OpenAPI } from "api-service-core";
/**
 * API Docs
 * --------
 * Attach an API resource to the OpenAPI definition.
 * We redact all of the "x-" attributes - unless disabled.
 *
 * @type {{name: string, description: string, title: string, usecase: [string], defaults: {path: string}, fn: module.exports.fn}}
 */
export default class apidocs implements IChassisFeature {
    name: string;
    title: string;
    defaults: {
        path: string;
    };
    static BLACKLIST: string[];
    static redact: (obj: any, allow_x?: boolean) => any;
    static document: (context: IChassisContext, openapi: OpenAPI, options: any) => any;
    fn(operation: IOperation, _options: any): (_req: any, res: any) => void;
}
