"use strict";
/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const api_service_core_1 = require("api-service-core");
/**
 * Redact
 * ------
 * Redact nominated fields based on JSON path rules:
 *
 *  Example: $.name  deletes { name: "hello" }
 *
 * @type {{name: string, title: string, fn: module.exports.fn}}
 */
class redact {
    constructor() {
        this.name = "api.redact";
        this.title = "Return payload with specified fields removed";
    }
    fn(_operation, options) {
        return function (req, res) {
            let model = req.body;
            api_service_core_1.Utils.transformByRule(model, options.rules, function (rule, item) {
                api_service_core_1.Utils.deleteJSON(item, rule.name);
            });
            res.status(200);
            res.send(model);
        };
    }
}
exports.default = redact;
;
//# sourceMappingURL=redact.js.map