import { IChassisContext, IChassisPlugin } from "api-service-core";
/**
 * plugin to handle JSON body
 *
 * @param context
 * @param options
 * @returns {exports}
 */
export default class UMA implements IChassisPlugin {
    name: string;
    title: string;
    uma_options: any;
    uma_discovery: any;
    context: IChassisContext;
    uma_pat: any;
    DEBUG: boolean;
    OPTIONS_WHITELIST: string[];
    constructor();
    install(context: IChassisContext, _options: any): void;
    discover_endpoints(context: IChassisContext): void;
    retrieve_PAT(context: IChassisContext): Promise<void>;
    post_form(url: string, headers: any, fields: any): Promise<any>;
    retrieveEntitlements(user_token: string, resource: string): Promise<any>;
    retrievePermissions(user_token: string, resource: string, scope: string, _params?: any): Promise<any>;
    getRSID(uri: string): Promise<any>;
    /**
     * Retrieve a Permission ticket:
     *
     *  1. lookup the RSID from the URI
     *  2. map the RSID + SCOPE into claims
     *  3. request ticket for the claims
     *
     * @param uri
     * @param scope
     */
    retrievePermissionTicket(uri: string, scope: string): Promise<any>;
    /**
     * Send a formatted `WWW-Authenticate` response
     * @param res
     * @param ticket
     */
    sendPermissionTicket(res: any, ticket: string): void;
    /**
     *
     * Retrieve a user's RPT
     *
     * @param user_jwt
     * @param ticket
     */
    retrieveRPT(user_jwt: string, ticket: string): Promise<any>;
    /**
     * retrieve RPT
     *
     * 1. retrievePermissionTicket
     * 2. retrieveRPT
     *
     * @param user_token
     * @param resource
     * @param scope
     */
    retrievePermissionRPT(user_token: string, resource: string, scope: string): Promise<{}>;
}
