import { IChassisContext, IChassisPlugin } from "api-service-core";
/**
 * The AMPQ feature uplifts local chassis events to the global event bus.
 *
 * It bind the AMQP service to this.amqp upon successful connection.
 *
 * @type {{usecase: [string], connect: module.exports.connect, publish_message: module.exports.publish_message, fn: module.exports.fn}}
 */
export default class amqp implements IChassisPlugin {
    constructor();
    name: string;
    title: string;
    amqp: any;
    /**
     * AMQP
     * ----
     * Connect to the AMQP message broker
     *
     * @param context
     * @param options
     * @param callback
     */
    connect: (context: any, options: any, callback: any) => void;
    /**
     * Send a message to a queue
     *
     * @param context
     * @param options
     * @param remote_queue
     * @param message
     * @param callback
     */
    publish_message: (context: IChassisContext, options: any, remote_queue: string, message: any, callback: Function) => void;
    /**
     * bridge local NodeJS events and the global AMQP message bus
     *
     * @param context
     * @param options
     * @returns {exports}
     */
    install(context: IChassisContext, options: any): void;
}
