"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const CORS = require("cors");
/**
 * plugin to handle JSON body
 *
 * @param context
 * @param options
 * @returns {exports}
 */
class cors {
    constructor() {
        this.name = "cors";
        this.title = "support for CORS";
    }
    install(context, options) {
        // open-up CORS for most verbs and all origins
        let cors_defaults = {
            "origin": "*",
            "methods": "GET,HEAD,PUT,PATCH,POST,DELETE,OPTIONS",
            "preflightContinue": false,
            "optionsSuccessStatus": 200
        };
        let cors_options = _.extend({}, cors_defaults, _.pick(options, _.keys(cors_defaults)));
        context.api.use(CORS(cors_options));
    }
}
exports.default = cors;
//# sourceMappingURL=cors.js.map