"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helmet = require("helmet");
/**
 * Harden
 * ------
 * Feature to protect micro-service from request-side abuse
 * Essentially configures Helmet
 *
 *  {
     *      harden:
     *          helmet-options
     *  }
 * @param context
 * @param options
 * @returns {exports}
 */
class harden {
    constructor() {
        this.name = "harden";
        this.title = "harden requests with Helmet";
    }
    install(context, options) {
        context.api.use(helmet(options));
        context.log({ code: "api:plugin:harden", message: "chassis hardened" });
    }
}
exports.default = harden;
//# sourceMappingURL=harden.js.map