/*************************************************************************
 *
 * Troven CONFIDENTIAL
 * __________________
 *
 *  (c) 2017-2020 Troven Pty Ltd
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Troven Pty Ltd and its licensors,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Troven Pty Ltd
 * and its suppliers and may be covered by International and Regional Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Troven Pty Ltd.
 */
import { IChassisContext, IChassisPlugin } from "api-service-core";
/**
 * Web Hooks
 * ---------
 * Feature connects selected local events to web hooks that notify a set of HTTP listeners.
 *
 * When the event is triggered, each listener receives an HTTP POST with a payload like:
 *  {
 *      code:  "some:operation",
 *      params: query params
 *      payload: req.body
 *  }
 *
 * @type {{name: string, title: string, _notify_listeners: module.exports._notify_listeners, fn: module.exports.fn}}
 */
export default class webhooks implements IChassisPlugin {
    name: string;
    title: string;
    LOW_SUCCESS_CODE: 200;
    HIGH_SUCCESS_CODE: 299;
    _notify_listeners: (context: any, flow: any, event_id: any, hook_id: any, event: any, options: any) => void;
    install(context: IChassisContext, _options: any): void;
}
