

import * as _ from "lodash";
import * as CORS from "cors";

import {IChassisContext, IChassisPlugin } from "api-service-core";

/**
 * plugin to handle JSON body
 *
 * @param context
 * @param options
 * @returns {exports}
 */
export default class cors implements IChassisPlugin {

    name = "cors";
    title = "support for CORS";

    install(context: IChassisContext, options: any) {

        // open-up CORS for most verbs and all origins
        let cors_defaults = {
            "origin": "*",
            "methods": "GET,HEAD,PUT,PATCH,POST,DELETE,OPTIONS",
            "preflightContinue": false,
            "optionsSuccessStatus": 200
          };

        let cors_options = _.extend( {}, cors_defaults, _.pick(options, _.keys(cors_defaults)) );

        context.api.use( CORS(cors_options) );
    }

}