import {IChassisContext, IChassisPlugin } from "api-service-core";

import * as helmet from 'helmet';

/**
 * Harden
 * ------
 * Feature to protect micro-service from request-side abuse
 * Essentially configures Helmet
 *
 *  {
     *      harden:
     *          helmet-options
     *  }
 * @param context
 * @param options
 * @returns {exports}
 */

export default class harden implements IChassisPlugin {

    name = "harden";
    title = "harden requests with Helmet";

    install(context: IChassisContext, options: any) {

        context.api.use( helmet( options ) );

        context.log({ code: "api:plugin:harden", message: "chassis hardened" });
    }

}